	.module chip.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\JIMPAT~1\MYDOCU~1\projects\SynthMod\200-1017\firmware\chip.c
	.dbfunc e port_init _port_init fV
	.even
_port_init::
	.dbline -1
	.dbline 10
; //ICC-AVR application builder : 11/9/2003 9:13:45 AM
; // Target : 8515
; // Crystal: 8.0000Mhz
; 
; #include <io8515v.h>
; #include <macros.h>
; #include "2001017.h"
; 
; void port_init(void)
; {
	.dbline 11
;  PORTA = 0xFF;
	ldi R24,255
	out 0x1b,R24
	.dbline 12
;  DDRA  = 0x00;
	clr R2
	out 0x1a,R2
	.dbline 13
;  PORTB = 0xFF;
	out 0x18,R24
	.dbline 14
;  DDRB  = 0x07;	//lower three bits are outputs (address lines to S/H)
	ldi R24,7
	out 0x17,R24
	.dbline 15
;  PORTC = 0xFF;
	ldi R24,255
	out 0x15,R24
	.dbline 16
;  DDRC  = 0x00;
	out 0x14,R2
	.dbline 17
;  PORTD = 0xFF;
	out 0x12,R24
	.dbline 18
;  DDRD  = 0x00; 
	out 0x11,R2
	.dbline -2
	.dbline 19
; }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e timer0_init _timer0_init fV
	.even
_timer0_init::
	.dbline -1
	.dbline 25
; 
; //TIMER0 initialisation - prescale:1024
; // desired value: 1000Hz
; // actual value: 1116.071Hz (10.4%)
; void timer0_init(void)
; {
	.dbline 26
;  TCCR0 = 0x00; //stop timer
	clr R2
	out 0x33,R2
	.dbline 27
;  TCNT0 = 0xF9; //set count value
	ldi R24,249
	out 0x32,R24
	.dbline 28
;  TCCR0 = 0x05; //start timer
	ldi R24,5
	out 0x33,R24
	.dbline -2
	.dbline 29
; }
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e timer1_init _timer1_init fV
	.even
_timer1_init::
	.dbline -1
	.dbline 41
; 
; //#pragma interrupt_handler timer0_ovf_isr:8
; //void timer0_ovf_isr(void)
; //{
; // TCNT0 = 0xF9; //reload counter value
; //}
; 
; //TIMER1 initialisation - prescale:8
; // desired value: 1000Hz
; // actual value: 1000.000Hz (0.0%)
; void timer1_init(void)
; {
	.dbline 42
;  TCCR1B = 0x00; //stop
	clr R2
	out 0x2e,R2
	.dbline 43
;  TCNT1H = 0xFC; //setup
	ldi R24,252
	out 0x2d,R24
	.dbline 44
;  TCNT1L = 0x18;
	ldi R24,24
	out 0x2c,R24
	.dbline 45
;  OCR1AH = 0x03;
	ldi R24,3
	out 0x2b,R24
	.dbline 46
;  OCR1AL = 0xE8;
	ldi R24,232
	out 0x2a,R24
	.dbline 47
;  OCR1BH = 0xfd;
	ldi R24,253
	out 0x29,R24
	.dbline 48
;  OCR1BL = 0xE8;
	ldi R24,232
	out 0x28,R24
	.dbline 49
;  TCCR1A = 0x10;
	ldi R24,16
	out 0x2f,R24
	.dbline 50
;  TCCR1B = 0x02; //start Timer
	ldi R24,2
	out 0x2e,R24
	.dbline -2
	.dbline 51
; }
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 12
	rjmp _timer1_ovf_isr
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\JIMPAT~1\MYDOCU~1\projects\SynthMod\200-1017\firmware\chip.c
	.dbfunc e timer1_ovf_isr _timer1_ovf_isr fV
	.even
_timer1_ovf_isr::
	st -y,R24
	in R24,0x3f
	st -y,R24
	.dbline -1
	.dbline 55
; 
; #pragma interrupt_handler timer1_ovf_isr:7
; void timer1_ovf_isr(void)
; {
	.dbline 56
;  TCNT1H = 0xFC; //reload counter high value
	ldi R24,252
	out 0x2d,R24
	.dbline 57
;  TCNT1L = 0x18; //reload counter low value
	ldi R24,24
	out 0x2c,R24
	.dbline -2
	.dbline 58
; }
L4:
	ld R24,y+
	out 0x3f,R24
	ld R24,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e uart0_init _uart0_init fV
	.even
_uart0_init::
	.dbline -1
	.dbline 64
; 
; //UART0 initialisation
; // desired baud rate: 31250
; // actual: baud rate:31250 (0.0%)
; void uart0_init(void)
; {
	.dbline 65
;  UCR  = 0x00; //disable while setting baud rate
	clr R2
	out 0xa,R2
	.dbline 66
;  UBRR = 0x0F; //set baud rate
	ldi R24,15
	out 0x9,R24
	.dbline 67
;  UCR  = 0xB8; //enable
	ldi R24,184
	out 0xa,R24
	.dbline -2
	.dbline 68
; }
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 2
	rjmp _int0_isr
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\JIMPAT~1\MYDOCU~1\projects\SynthMod\200-1017\firmware\chip.c
	.dbfunc e int0_isr _int0_isr fV
;              x -> y+0
	.even
_int0_isr::
	st -y,R2
	st -y,R3
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	sbiw R28,2
	.dbline -1
	.dbline 86
; 
; //#pragma interrupt_handler uart0_rx_isr:10
; //void uart0_rx_isr(void)
; //{
;  //uart has received a character in UDR
; //}
; 
; //#pragma interrupt_handler uart0_udre_isr:11
; //void uart0_udre_isr(void)
; //{
;  //character transferred to shift register so UDR is now empty
; //}
; 
; extern int DAC_Shad[8];	//this is where the DAC is output from
; extern int CurrentDac;
; #pragma interrupt_handler int0_isr:2
; void int0_isr(void)
; {
	.dbline 93
;  //external interupt on INT0
;  	union {
;     	int v;
;         char cv[2];
; 	}x;
;     
;     CLEAR_STROBE_IRQ = x.cv[1];	//reset interrupt
	ldd R2,y+1
	sts 35840,R2
	.dbline 94
; 	++CurrentDac;
	lds R24,_CurrentDac
	lds R25,_CurrentDac+1
	adiw R24,1
	sts _CurrentDac+1,R25
	sts _CurrentDac,R24
	.dbline 95
; 	if(CurrentDac >= 8) CurrentDac = 0;
	cpi R24,8
	ldi R30,0
	cpc R25,R30
	brlt L9
	.dbline 95
	clr R2
	clr R3
	sts _CurrentDac+1,R3
	sts _CurrentDac,R2
L9:
	.dbline 96
;   	x.v = DAC_Shad[CurrentDac];
	ldi R24,<_DAC_Shad
	ldi R25,>_DAC_Shad
	lds R30,_CurrentDac
	lds R31,_CurrentDac+1
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldd R3,z+1
	std y+1,R3
	std y+0,R2
	.dbline 97
;     PORTB = CurrentDac & 0x7;	//set S/H address Lines
	lds R24,_CurrentDac
	lds R25,_CurrentDac+1
	andi R24,7
	andi R25,0
	out 0x18,R24
	.dbline 98
; 	DAC_LOW = x.cv[0];
	sts 34816,R2
	.dbline 99
;     DAC_HIGH = x.cv[1];
	ldd R2,y+1
	sts 32768,R2
	.dbline 100
;     DAC_LOAD = x.cv[1];			//arm S/H strobe and wait for interrupt...
	sts 33792,R2
	.dbline -2
	.dbline 101
; }
L6:
	adiw R28,2
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R3,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbsym l x 0 X
	.dbend
	.area vector(rom, abs)
	.org 4
	rjmp _int1_isr
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\JIMPAT~1\MYDOCU~1\projects\SynthMod\200-1017\firmware\chip.c
	.dbfunc e int1_isr _int1_isr fV
	.even
_int1_isr::
	.dbline -1
	.dbline 105
; 
; #pragma interrupt_handler int1_isr:3
; void int1_isr(void)
; {
	.dbline -2
	.dbline 107
;  //external interupt on INT1
; }
L13:
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e init_devices _init_devices fV
	.even
_init_devices::
	.dbline -1
	.dbline 111
; 
; //call this routine to initialise all peripherals
; void init_devices(void)
; {
	.dbline 113
;  //stop errant interrupts until set up
; 	CLI(); //disable all interrupts
	cli
	.dbline 114
; 	port_init();
	rcall _port_init
	.dbline 116
; // timer0_init();
; 	timer1_init();
	rcall _timer1_init
	.dbline 122
; // uart0_init();
; 
; // MCUCR = 0x8B;
; 	//INT0 rising edge
;     //INT1 Falling edge
; 	MCUCR = (1 << SRE) | (1 << SRW) | (1 << ISC00) | (1 << ISC01);	
	ldi R24,195
	out 0x35,R24
	.dbline 124
; //	GIMSK = 0xC0;
; 	GIMSK = (1 << INT0);
	ldi R24,64
	out 0x3b,R24
	.dbline 125
;  	TIMSK = (1 << TOIE1);
	ldi R24,128
	out 0x39,R24
	.dbline 127
;     
;  SEI(); //re-enable interrupts
	sei
	.dbline -2
	.dbline 129
;  //all peripherals are now initialised
; }
L14:
	.dbline 0 ; func end
	ret
	.dbend
